# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from enum import Enum
from six import with_metaclass
from azure.core import CaseInsensitiveEnumMeta


class CreatedByType(with_metaclass(CaseInsensitiveEnumMeta, str, Enum)):
    """The type of identity that created the resource.
    """

    USER = "User"
    APPLICATION = "Application"
    MANAGED_IDENTITY = "ManagedIdentity"
    KEY = "Key"

class EncryptionAtHost(with_metaclass(CaseInsensitiveEnumMeta, str, Enum)):
    """EncryptionAtHost represents encryption at host state
    """

    DISABLED = "Disabled"
    ENABLED = "Enabled"

class FipsValidatedModules(with_metaclass(CaseInsensitiveEnumMeta, str, Enum)):
    """FipsValidatedModules determines if FIPS is used.
    """

    DISABLED = "Disabled"
    ENABLED = "Enabled"

class ProvisioningState(with_metaclass(CaseInsensitiveEnumMeta, str, Enum)):
    """ProvisioningState represents a provisioning state.
    """

    ADMIN_UPDATING = "AdminUpdating"
    CREATING = "Creating"
    DELETING = "Deleting"
    FAILED = "Failed"
    SUCCEEDED = "Succeeded"
    UPDATING = "Updating"

class Visibility(with_metaclass(CaseInsensitiveEnumMeta, str, Enum)):
    """Visibility represents visibility.
    """

    PRIVATE = "Private"
    PUBLIC = "Public"
